<template>
  <div class="Calendar">
    <RadioButton
      :options="{ Day: 'day', Week: 'week', Month: 'month' }"
      :modelValue="view"
      class="Calendar__SelectView"
      label="View"
      @input="changeView"
    />
    <div ref="tuiCalendar"></div>
  </div>
</template>
<script>
import Calendar from 'tui-calendar'
import RadioButton from '@/components/controls/RadioButton'
import { onMounted, ref } from 'vue'

const scheduleNeedProp = ['start', 'category']

export default {
  name: 'Calendar',
  components: { RadioButton },
  props: {
    calendars: {
      type: Array,
      default() {
        return []
      },
    },
    schedules: {
      type: Array,
      default() {
        return []
      },
      validator(value) {
        let notHave = false
        value.forEach((schedule) => {
          notHave = scheduleNeedProp.some(
            (prop) => !Object.prototype.hasOwnProperty.call(schedule, prop)
          )
        })
        return !notHave
      },
    },
    view: {
      type: String,
      default: 'week',
    },
    taskView: {
      type: [Boolean, Array],
      default: true,
    },
    scheduleView: {
      type: [Boolean, Array],
      default: true,
    },
    theme: {
      type: Object,
      default() {
        return {}
      },
    },
    template: {
      type: Object,
      default() {
        return {}
      },
    },
    week: {
      type: Object,
      default() {
        return {}
      },
    },
    month: {
      type: Object,
      default() {
        return {}
      },
    },
    useCreationPopup: {
      type: Boolean,
      default: true,
    },
    useDetailPopup: {
      type: Boolean,
      default: true,
    },
    timezones: {
      type: Array,
      default() {
        return []
      },
    },
    disableDblClick: {
      type: Boolean,
      default: false,
    },
    disableClick: {
      type: Boolean,
      default: false,
    },
    isReadOnly: {
      type: Boolean,
      default: false,
    },
    usageStatistics: {
      type: Boolean,
      default: true,
    },
  },
  watch: {
    calendars(newValue) {
      this.calendarInstance.setCalendars(newValue)
    },
    schedules() {
      this.calendarInstance.clear()
      this.reflectSchedules()
    },
    view(newValue) {
      this.calendarInstance.changeView(newValue, true)
    },
    taskView(newValue) {
      this.calendarInstance.setOptions({ taskView: newValue })
    },
    scheduleView(newValue) {
      this.calendarInstance.setOptions({ scheduleView: newValue })
    },
    theme: {
      handler(newValue) {
        this.calendarInstance.setTheme(this.cloneData(newValue))
      },
      deep: true,
    },
    week: {
      handler(newValue) {
        const silent = this.view !== 'week' && this.view !== 'day'
        this.calendarInstance.setOptions(
          { week: this.cloneData(newValue) },
          silent
        )
      },
      deep: true,
    },
    month: {
      handler(newValue) {
        const silent = this.view !== 'month'
        this.calendarInstance.setOptions(
          { month: this.cloneData(newValue) },
          silent
        )
      },
      deep: true,
    },
    timezones(newValue) {
      this.calendarInstance.setOptions({ timezones: newValue })
    },
    disableDblClick(newValue) {
      this.calendarInstance.setOptions({ disableDblClick: newValue })
    },
    disableClick(newValue) {
      this.calendarInstance.setOptions({ disableClick: newValue })
    },
    isReadOnly(newValue) {
      this.calendarInstance.setOptions({ isReadOnly: newValue })
    },
  },

  beforeUnmount() {
    this.calendarInstance.off()
    this.calendarInstance.destroy()
  },
  methods: {
    cloneData(data) {
      return JSON.parse(JSON.stringify(data))
    },
    getRootElement() {
      return this.$refs.tuiCalendar
    },
  },

  setup(props, context) {
    let calendarInstance = {}

    const tuiCalendar = ref(null)

    onMounted(() => {
      calendarInstance = new Calendar(tuiCalendar.value, {
        defaultView: props.view,
        taskView: props.taskView,
        scheduleView: props.scheduleView,
        theme: props.theme,
        template: props.template,
        week: props.week,
        month: props.month,
        calendars: props.calendars,
        useCreationPopup: props.useCreationPopup,
        useDetailPopup: props.useDetailPopup,
        timezones: props.timezones,
        disableDblClick: props.disableDblClick,
        disableClick: props.disableClick,
        isReadOnly: props.isReadOnly,
        usageStatistics: props.usageStatistics,
      })
      for (const eventName of Object.keys(context.attrs)) {
        calendarInstance.on(eventName, (...args) =>
          context.emit(eventName, ...args)
        )
      }
      if (props.schedules.length > 0) {
        if (calendarInstance['createSchedules']) {
          calendarInstance['createSchedules'](...props.schedules)
        }
      }
    })

    return {
      calendarInstance,
      tuiCalendar,
      changeView: (view) => calendarInstance.changeView(view, true),
    }
  },
}
</script>
